Subject: PyPy is Broken

From: "jgart" <[email-masked]>
Date: Mon, 03 Feb 2025 09:18:00 +0000

Hi,

I am reporting a bug that PyPy is broken on Guix and so users are aware that you can't currently use PyPy properly in a guix shell with Guix.

How do you reproduce this issue?

Run the following:

make -j6 && ./pre-inst-env guix shell pypy python-django strace ltrace

ltrace -e getenv pypy -c "import django"

Observe the following PYTHONPATH 

libpypy3.10-c.so->getenv("PYTHONPATH")                                                           = nil

If instead I run the following commands I don't get an error response from ltrace:

make -j6 && ./pre-inst-env guix shell python-wrapper python-django strace ltrace

ltrace -e getenv python -c "import django"

all the best,

jgart

ps

Not sure when I can prioritize fixing this. 

I am thinking that it might not be as trivial as setting the native-search-paths in the pypy package record.

I tried already and it didn't resolve the python paths.

My hypothesis is that the python-build-system or pyproject-build-system makes assumptions that are not compatible with how pypy sets and looks up paths.

I'll have to do some more experiments to find out more about that.